<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;
use Teknisa\SM\Service\Sm00001000PropostaLocalAtendService;

class Sm00001000PropostaLocalAtendController extends SMCrud {
    protected $dataSourceName = 'fct_relacestruturaprop_widget';
    protected $newCode;
    protected $serviceLocAtendProp;

    public function __construct ($crudService, $environment, NewCode $newCode, Sm00001000PropostaLocalAtendService $serviceLocAtendProp) {
        parent::__construct($crudService, $environment);
        $this->newCode = $newCode;
        $this->serviceLocAtendProp  = $serviceLocAtendProp;
    }
    
    public function save(Request $request, Response $response) {
        try{
            
            $rows = $request->getDataSet()->getRows();
            
            foreach($rows as $chave => &$row) {
                
                $nrEstruturam = $row["NRESTRUTURAM"];
                $nrSeqOrcamento = $row["NRSEQORCAMENTO"];
                $row['IDRELACESTRUTURA'] = "PROPOSTA";
                
                $Valida = $this->serviceLocAtendProp->validaLocalAtend($nrEstruturam, $nrSeqOrcamento);
                
                if ($Valida == false){
                    $row['NRRELACESTRUTPROP'] = $this->newCode->getCodeByTableName("NRRELACESTRUTPROP", $this->environment->getNrOrg(), 1, 10, true);
                }
                else{
                    unset($rows[$chave]);
                }
            }
            
            $novoRequest = new Request\DataSet(new DataSet($this->dataSourceName, $rows), $request->getRoutePath(), $request->getMethod(), $request->getUserId());
            $response = new Response();
            parent::save($novoRequest, $response);
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
        
    }
     /**
     * A função "deletarPaieFilhos" exclui  o local de Atendimento 
     * e os filhos.
     */
    
    public function deletarPaieFilhos(Request\Row $request, Response $response) {
        try{
            $row = $request->getRow();
            $nrEstruturam = $row["NRESTRUTURAM"];
            $nrSeqOrcamento = $row["NRSEQORCAMENTO"];
            $delArvore = $this->serviceLocAtendProp->deletarPaieFilhos($nrEstruturam, $nrSeqOrcamento);
        }
        catch (\Exception $e) {
                $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }  
}
