<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00048000ImpostoFactory;
use Teknisa\Libs\Util\Environment;

class Sm00048000ImpostoService {
    protected $impostoFactory;
    protected $environment;
    public function __construct(Sm00048000ImpostoFactory $impostoFactory, Environment $environment){
        $this->impostoFactory = $impostoFactory;    
        $this->environment    = $environment;    
    }
    /**
     * Deleta alguns servicos do imposto ou o imposto inteiro
    **/
    public function deleteImposto($cdimposto, $nrorg, $nrimpostoserv){
        if($nrimpostoserv !== null)
            $nrimpostoserv = implode(",", $nrimpostoserv);
        $params = array(
            "NRORG"         => $nrorg,
            "CDIMPOSTO"     => $cdimposto, 
        );
        if($nrimpostoserv == "" && $nrimpostoserv == null)
            $this->impostoFactory->deleteImposto($params);
        else 
            $this->impostoFactory->deleteServicoImposto($params, $nrimpostoserv);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
    **/
    public function salvarEdicaoImposto($cdimposto, $nrorg, $vrprecimposto){
        $params = array(
            "NRORG"         => $nrorg,
            "CDIMPOSTO"     => $cdimposto,
            "VRPRECIMPOSTO" => $vrprecimposto
        );
        $this->impostoFactory->salvarEdicaoImposto($params);
    }
}